#include <bindings.dsl.h>
#include <apr_allocator.h>

module Bindings.APR.Allocator where
#strict_import
import Bindings.APR
import Bindings.APR.Allocator.Types
import Bindings.APR.ErrNo
import Bindings.APR.Thread.Mutex
import Bindings.APR.Pools

#num APR_MEMNODE_T_SIZE
#num APR_ALLOCATOR_MAX_FREE_UNLIMITED

#ccall apr_allocator_create , Ptr (Ptr <apr_allocator_t>) -> IO <apr_status_t>
#ccall apr_allocator_destroy, Ptr <apr_allocator_t> -> IO ()
#ccall apr_allocator_alloc  , Ptr <apr_allocator_t> -> <apr_size_t> -> IO (Ptr <apr_memnode_t>)
#ccall apr_allocator_free   , Ptr <apr_allocator_t> -> Ptr <apr_memnode_t> -> IO ()

#ccall apr_allocator_owner_set, Ptr <apr_allocator_t> -> Ptr <apr_pool_t> -> IO ()
#ccall apr_allocator_owner_get, Ptr <apr_allocator_t> -> IO (Ptr <apr_pool_t>)

#ccall apr_allocator_max_free_set, Ptr <apr_allocator_t> -> <apr_size_t> -> IO ()

#ccall apr_allocator_mutex_set, Ptr <apr_allocator_t> -> Ptr <apr_thread_mutex_t> -> IO ()
#ccall apr_allocator_mutex_get, Ptr <apr_allocator_t> -> IO (Ptr <apr_thread_mutex_t>)
